unit AdvGridWithTouchSpin.EditLink;

interface

uses
  System.SysUtils,
  Vcl.Graphics, Vcl.Controls,  Vcl.Forms,
  AdvUtil, AdvObj, BaseGrid, AdvGrid,
  AdvMultiButtonEdit;

type
  TTouchSpinEditLink = class(TEditLink)
  private
    FSpinEdit: TAdvTouchSpinEdit;
  protected
    procedure EditExit(Sender:TObject);
  public
    procedure CreateEditor(AParent: TWinControl); override;
    procedure DestroyEditor; override;
    procedure SetCellProps(AColor: TColor; AFont: TFont); override;
    function GetEditorValue: string; override;
    procedure SetEditorValue(S: string); override;
    function GetEditControl: TWinControl; override;
    property SpinEdit: TAdvTouchSpinEdit read FSpinEdit;
  end;

implementation

{ TTouchSpinEditLink }

procedure TTouchSpinEditLink.CreateEditor(AParent: TWinControl);
begin
   FSpinEdit := TAdvTouchSpinEdit.Create(Grid);
   FSpinEdit.BorderStyle := bsNone;
   FSpinEdit.OnKeydown := EditKeyDown;
   FSpinEdit.OnExit := EditExit;
   FSpinEdit.Width := 0;
   FSpinEdit.Height := 0;
   FSpinEdit.Parent := AParent;
//   WantKeyLeftRight := True;
//   WantKeyHomeEnd := True;
end;

procedure TTouchSpinEditLink.DestroyEditor;
begin
  if Assigned(FSpinEdit) then
    FSpinEdit.Free;
  FSpinEdit := nil;
end;

procedure TTouchSpinEditLink.EditExit(Sender: TObject);
begin
  HideEditor;
end;

function TTouchSpinEditLink.GetEditControl: TWinControl;
begin
  Result := FSpinEdit;
end;

function TTouchSpinEditLink.GetEditorValue: string;
begin
  Result := FSpinEdit.Text;
end;

procedure TTouchSpinEditLink.SetCellProps(AColor: TColor; AFont: TFont);
begin
  FSpinEdit.Color := AColor;
  FSpinEdit.Font := AFont;
end;

procedure TTouchSpinEditLink.SetEditorValue(S: string);
begin
  FSpinEdit.Text := S;
end;

end.
